import express from 'express';
import filesService from '../services/files.service';
import debug from 'debug';

const log: debug.IDebugger = debug('app:files-controller');
class FilesController {

    async listFiles(req: express.Request, res: express.Response) {
        const files = await filesService.list(100, 0);
        res.status(200).send(files);
    }

    async createFile(req: express.Request, res: express.Response) {
        res.status(200).send(req.file);
    }

    async removeFile(req: express.Request, res: express.Response) {
        try {
            await filesService.deleteById(req.params.filename);
            res.status(204).send(`file ${req.params.filename} remove successfully`);
        } catch (error) {
            console.log(error);
            res.status(409).send(`Could not delete file`);
        }
    }
}

export default new FilesController();