$('document').ready(function () {
    importCssFile('assets/css/carousel.css');
});

function initCarousel(options) {
    var elementId = options.elementId;
    var isResponsive = typeof options.responsive !== 'undefined' ? options.responsive : true;
    var slides = typeof options.slides !== 'undefined' ? options.slides : 5;

    var responsive = [];
    if (isResponsive) {
        responsive = [
            {
                breakpoint: 1626,
                settings: {
                    slidesToShow: 4,
                    slidesToScroll: 4,
                }
            },
            {
                breakpoint: 1324,
                settings: {
                    slidesToShow: 3,
                    slidesToScroll: 3
                }
            },
            {
                breakpoint: 1022,
                settings: {
                    slidesToShow: 2,
                    slidesToScroll: 2
                }
            },
            {
                breakpoint: 720,
                settings: {
                    slidesToShow: 1,
                    slidesToScroll: 1
                }
            }
        ];
    }

    $("#" + elementId).slick({
        slidesToShow: slides,
        slidesToScroll: slides,
        prevArrow: '<span class="carousel-arrow carousel-arrow-prev"><i class="fas fa-angle-left"></i></span>',
        nextArrow: '<span class="carousel-arrow carousel-arrow-next"><i class="fas fa-angle-right"></i></span>',
        responsive: responsive
    });

    $(function () {
        $('.carousel-elem').hover(function () {
            $(this).find('.carousel-elem-fill').css('opacity', 0.5);
            $(this).find('.carousel-elem-play').css('opacity', 1);
            $(this).find('.carousel-elem-info').css('opacity', 1);
        }, function () {
            $(this).find('.carousel-elem-fill').css('opacity', 1);
            $(this).find('.carousel-elem-play').css('opacity', .7);
            $(this).find('.carousel-elem-info').css('opacity', 0);
        });
    });
}