$('document').ready(function () {
    importCssFile('assets/css/channels-carousel.css');
    importJsFile('assets/js/carousel.js');
});

function initChannelsCarousel(channels, options) {
    var title = typeof options.title !== 'undefined' ? options.title : false;
    var featured = typeof options.featured !== 'undefined' ? options.featured : false;

    var carousel_class = "";
    if (featured) {
        carousel_class = "carousel-elem-big";
    }

    var title_template = '';
    if (title) {
        title_template +=
            '<div class="channels-carousel-title">' +
            '<p>' + title + '</p>' +
            '</div>';
    }

    var template;
    template =
        '<div class="channels-carousel">' +
        title_template +
        '<div class="carousel" id="' + options.elementId + '">' +
        '</div>' +
        '</div>';

    $("#" + options.parentId).append(template);

    for (var i = 0; i < channels.length; i++) {
        var channel = channels[i];
        var channelTemplate = '';

        channelTemplate +=
            '<div class="carousel-elem ' + carousel_class + '" style="background-image: url(' + channel.poster + ');">' +
            '<div class="carousel-elem-fill"></div>' +
            '<div class="carousel-elem-content">' +
            '<div class="carousel-elem-play">' +
            '<a href="theater?id=' + channel.id + '"><i class="fas fa-play"></i></a>' +
            '</div>' +

            '<div class="carousel-elem-info">' +
            '<h3 class="carousel-elem-info-label" id="' + options.elementId + '-' + channel.id + '-label' + '"></h3>' +
            '<h2 class="carousel-elem-info-title" id="' + options.elementId + '-' + channel.id + '-title' + '"></h2>' +
            '</div>' +

            '<div>' +
            '<img class="carousel-elem-logo" src="' + channel.logo + '">' +
            '</div>' +
            '</div>' +
            '</div>';

        $("#" + options.elementId).append(channelTemplate);
        fillCarouselChannelEpg(options.elementId, channel);
    }
    initCarousel(options);
}

function fillCarouselChannelEpg(elementId, channel) {
    var selector = '#' + elementId + '-' + channel.id;
    getChannelGuide(channel)
        .then(
            function (guide) {
                $(selector + '-label').text("Agora");
                $(selector + '-title').text(guide[0].title);
            }
        )
        .catch(
            function (error) {
                $(selector + '-label').text("");
                $(selector + '-title').text("");
            }
        );
}