//TODO solução paliativa
var newLayoutGids = ['o1ch1', 'o1ch4', 'o1ch6', 'o1ch8', 'o1ch9', 'o1ch11', 'o1ch12', 'o1ch14', 'o1ch15', 'o1ch16',
    'o1ch17', 'o1ch18', 'o1ch19', 'o1ch20', 'o1ch21', 'o1ch23', 'o1ch24', 'o1ch25', 'o1ch26', 'o1ch27', 'o1ch28',
    'o18556ch36', 'o2ch54', 'o1ch29', 'o2ch56','BZfJAdG', 'BZfJAdK', 'BZfJAde', 'BZfJAde0', 'BZfJAde1', 'BZfJAde2', 'BZfJAde3', 'BZfJAde4', 'BZfJAde5', 'BZfJAdeX', 'BZfJAdeY', 'BZfJAdi0', 'BZfJAdi1', 'BZfJAdi2', 'BZfJAdi3', 'BZfJAdi4', 'BZfJAdi5', 'BZfJAdiW', 'BZfJAdiX', 'BZfJAdiZ', 'BZfJAdq', 'BZfJAdy'];

/**
 * @param {String} string url or relative path
 * @returns {boolean}
 */
function isRelative(url) {
    return url.indexOf("://") < 0;
}

function getChannels(category) {
    var token = Cookies.get('token');
    var getUrl = getManagerUrl() + "/channels?t=" + token;
    if (category !== "all") {
        getUrl += "&c=" + category;
    }

    return new Promise(function (resolve, reject) {

        $.ajax({
            "url": getUrl,
            "method": "GET",
            "headers": {
                "Accept": "application/json",
                "Content-Type": "application/json"
            },
            "dataType": "json",
            "crossDomain": true,
            success: function (channels) {
                try{
                    var firstHealthChannel = -1;
                    for (var i = 0; i < channels.length; i++) {
                        if (channels[i].health > 0 && firstHealthChannel < 0) {
                            firstHealthChannel = i;
                        }

                        if (channels[i].logo !== null && isRelative(channels[i].logo)) {
                            channels[i].logo = getManagerUrl() + channels[i].logo;
                        }

                        //Caso não haja posters
                        if (channels[i].poster == "" || typeof channels[i].poster == "undefined") {
                            if (newLayoutGids.includes(channels[i].gid)) { //Pega o padrão de acordo com o gid. Note: deprecated since manager 1.8
                                channels[i].poster = 'https://s2.cdn.tv.br/new-layout/poster/' + channels[i].gid + '.png';
                            }
                            else if (newLayoutGids.includes(channels[i].uid)){ //Pega o padrão de acordo com o uid.
                                channels[i].poster = 'https://s2.cdn.tv.br/new-layout/poster/' + channels[i].uid + '.png';
                            }
                            else {
                                channels[i].poster = 'https://s2.cdn.tv.br/new-layout/poster/default.png';
                            }
                        } else if (channels[i].poster !== null && isRelative(channels[i].poster)) {
                            channels[i].poster = getManagerUrl() + channels[i].poster;
                        }

                        
                    }

                    if (firstHealthChannel >= 0) {
                        var featuredChannel = channels[firstHealthChannel];
                        var returnData = {
                            "channels": channels,
                            "featuredChannel": featuredChannel,
                        };
                        resolve(returnData);
                    } else {
                        reject();
                    }
                }catch(e){
                    reject();
                    console.log(e);
                }
            },
            error: function () {
                reject();
            }
        });
    });
}

function getChannelInfo(id) {
    var token = Cookies.get('token');
    var getUrl = getManagerUrl() + "/channels/" + id + "?t=" + token;

    return new Promise(function (resolve, reject) {

        $.ajax({
            "url": getUrl,
            "method": "GET",
            "headers": {
                "Accept": "application/json",
                "Content-Type": "application/json"
            },
            "dataType": "json",
            "crossDomain": true,
            success: function (channel) {
                //posters
                try{
                    if (channel.logo !== null && isRelative(channel.logo)) {
                        channel.logo = getManagerUrl() + channel.logo;
                    }

                    if (channel.poster == "" || typeof channel.poster == "undefined") {
                        if (newLayoutGids.includes(channel.gid)) {
                            channel.poster = 'https://s2.cdn.tv.br/new-layout/poster/' + channel.gid + '.png';
                        } else if (newLayoutGids.includes(channel.uid)){ //Pega o padrão de acordo com o uid.
                            channel.poster = 'https://s2.cdn.tv.br/new-layout/poster/' + channel.uid + '.png';
                        } else {
                            channel.poster = 'https://s2.cdn.tv.br/new-layout/poster/default.png';
                        }
                    } else if (channel.poster !== null && isRelative(channel.poster)) {
                        channel.poster = getManagerUrl() + channel.poster;
                    }
                    
                    getChannelGuide(channel)
                        .then(
                            function (guide) {
                                channel.guideData = guide;
                                resolve(channel);
                            }
                        ).catch(
                        function () {
                            resolve(channel);
                        }
                    );
                }catch(e){
                    console.log(e);
                    reject();
                }
            },
            error: function () {
                reject();
            }
        });
    });
}

function getChannelGuide(channel) {
    var token = Cookies.get('token');
    var getUrl = getManagerUrl() + channel.guide + "?t=" + token + "&now";

    return new Promise(function (resolve, reject) {

        $.ajax({
            "url": getUrl,
            "method": "GET",
            "headers": {
                "Accept": "application/json",
                "Content-Type": "application/json"
            },
            "dataType": "json",
            "crossDomain": true,
            success: function (data) {
                try{
                    if (typeof data !== "undefined" && data.length > 0) {
                        resolve(data);
                    } else {
                        reject();
                    }
                }catch(e){
                    console.log(e);
                    reject();
                }
            },
            error: function () {
                reject();
            }
        });
    });
}