var is_demo;
var is_economic;
var managerUrl;
var footerTemplate;
var basepath = '';
var currentVersion;
var protocol;
var providersList = null;
var is_restrict;

function setIsRestrict(_restrict) {
    is_restrict = _restrict;
}

function isRestrict() {
    return is_restrict;
}

function setIsEconomic(_economic) {
    is_economic = _economic;
}

function isEconomic() {
    return is_economic;
}

function setIsDemo(_demo) {
    is_demo = _demo;
}

function isDemo() {
    return is_demo;
}

function setManagerUrl(_url) {
    managerUrl = _url;
}

function getManagerUrl() {
    return managerUrl;
}

function setBasePath(_basepath) {
    basepath = _basepath;
}

function getBasePath() {
    return basepath;
}

function setCurrentVersion(_version) {
    currentVersion = _version;
}

function getCurrentVersion() {
    return currentVersion;
}

function setProtocol(_protocol) {
    protocol = _protocol;
}

function getProtocol() {
    return protocol;
}

function setProvidersList(_providersList) {
    providersList = _providersList;
}

function getProvidersList() {
    return providersList;
}

function initMain() {
    importCssFile('assets/css/main.css');
    importCssFile('assets/css/modal.css');
    importJsFile('assets/js/toast.js');

    return new Promise(function (resolve, reject) {
        $.ajax({
            dataType: "json",
            url: "assets/json/config.json",
            success: function (data) {
                try {
                    var basepath = typeof data.basepath !== 'undefined' ? data.basepath : '';
                    var version = typeof data.version !== 'undefined' ? data.version : false;
                    setBasePath(basepath);
                    setCurrentVersion(version);
                } catch (e) {
                    setBasePath('');
                    setCurrentVersion(false);
                    console.log(e);
                }
            },
            error: function (xhr, status, error) {
                reject({ error, status, file: "assets/json/config.json" });
                setBasePath('');
                setCurrentVersion(false);
            },
        });

        $.ajax({
            dataType: "json",
            url: "theme/config.json",
            success: function (theme) {
                try {
                    var protocol = typeof theme.protocol !== 'undefined' ? theme.protocol : 'https';
                    setProtocol(protocol);
                    var systemName = theme.name;
                    var isDemo = typeof theme.demo !== 'undefined' ? theme.demo : false;
                    var providers = typeof theme.providersList !== 'undefined' ? theme.providersList : null;

                    var managerUrl;
                    if (providers) {
                        setProvidersList(providers);

                        var edgeHost = Cookies.get('edgeHost');
                        if (edgeHost) {
                            managerUrl = protocol + '://' + edgeHost;
                        } else {
                            managerUrl = protocol + '://' + theme.managerUrl;
                        }
                    } else {
                        managerUrl = protocol + '://' + theme.managerUrl;
                    }

                    $('#player-favicon').attr('href', managerUrl + '/logo/favicon.png');
                    $('[data-react-helmet]').html(systemName);

                    setIsDemo(isDemo);
                    setManagerUrl(managerUrl);
                    importCssFile('theme/custom-style.css');
                    importJsFile('theme/style.js');
                    setFooterTemplate(systemName);
                    resolve();
                } catch (e) {
                    console.log(e)
                }
            },
            error: function (xhr, status, error) {
                console.log(xhr);
                reject({ error, status, file: "theme/config.json" });
            },
        });
    });
}

//Other functions
function initFooter() {
    $("body").append(getFooterTemplate());
}

function setFooterTemplate(systemName) {
    var template = '';
    var year = new Date().getFullYear();

    if (getCurrentVersion()) {
        template = '<p class="footer" id="footer">© 2017-' + year + ' ' + systemName + ' v' + getCurrentVersion() + '</p>';
    } else {
        template = '<p class="footer" id="footer">© 2017-' + year + ' ' + systemName + '</p>';
    }
    footerTemplate = template;
}

function getFooterTemplate() {
    return footerTemplate;
}

function initStillWatchingModal() {
    $('body').append('<div id="still-watching-modal" class="modal"></div>');

    var stillWatchingModal = $('#still-watching-modal');

    if (isDemo()) {
        stillWatchingModal.html(demoExpirationTemplate());
    } else {
        stillWatchingModal.html(stillWatchingTemplate());
    }
}

function initRestrictModal() {
    $('body').append('<div id="restrict-modal" class="modal"></div>');

    var restrictModal = $('#restrict-modal');

    restrictModal.html(restrictTemplate());
}

function restrictTemplate() {
    var template;
    template =
        '<div class="modal-animate">' +
        '<div class="modal-content">' +
        '<div class="modal-container">' +
        '<form id="parpass-form" onsubmit="return validateRestrictPassword();">' +
        '<p class="modal-header-text">Acesso restrito!</p>' +
        '<p class="modal-body-text">Para continuar, insira a senha no  campo a baixo:</p>' +
        '<div class="modal-group modal-input-filled"><input class="modal-input" type="password" name="pwd-restrict" id="pwd-restrict" required=""><p class="modal-input-label">Senha</p></div>' +
        '<div class="modal-group"><button class="modal-button" type="submit">Confirmar</button></div>' +
        '</form>' +
        '</div>' +
        '</div>';

    return template;
}

function demoExpirationTemplate() {
    var template;
    template =
        '<div class="modal-animate">' +
        '<div class="modal-content">' +
        '<div class="modal-container">' +
        '<p class="modal-header-text" style="margin: 15px;">Seu período de demonstração expirou!</p>' +
        '</div>' +
        '</div>' +
        '</div>';

    return template;
}

function stillWatchingTemplate() {
    var template;
    template =
        '<div class="modal-animate">' +
        '<div class="modal-content">' +
        '<div class="modal-container">' +
        '<p class="modal-header-text">Você ainda está assistindo este canal?</p>' +
        '<button class="modal-button" onclick="hideStillWatchingModal(); refreshPlayer();">Continuar Assistindo</button>' +
        '</div>' +
        '</div>' +
        '</div>';

    return template;
}

function showStillWatchingModal() {
    $('#still-watching-modal').show();
}

function hideStillWatchingModal() {
    $('#still-watching-modal').hide();
}

function showRestrictModal() {
    $('#restrict-modal').show();
}

function hideRestrictModal() {
    $('#restrict-modal').hide();
}

function makeLogin(data) {
    return new Promise(function (resolve, reject) {
        var dataJson = JSON.parse(data);

        var managerUrl = getManagerUrl();
        if (typeof dataJson.provider !== "undefined") {
            managerUrl = getProtocol() + "://" + dataJson.provider;
            setManagerUrl(managerUrl);
            Cookies.set("edgeHost", dataJson.provider);
        }

        $.ajax({
            "url": getManagerUrl() + "/auth",
            "method": "POST",
            "headers": {
                "Accept": "application/json",
                "Content-Type": "application/json"
            },
            "crossDomain": true,
            "data": data,
            "dataType": "json",
            success: function (response) {
                try {
                    var now = new Date();
                    var lifetime = response.lifetime * 1000;
                    var expire = now.getTime() + lifetime;

                    var dataJson = JSON.parse(data);
                    var isToken = typeof dataJson.token !== 'undefined';

                    Cookies.set('token', response.token);
                    Cookies.set('expire', expire);
                    Cookies.set('parpass', response.parpass);
                    setIsEconomic(response.economic);

                    if (!isToken) {
                        Cookies.set('rtoken', response.rtoken);
                        Cookies.set('user', response.name);
                    }

                    resolve(response.token);
                } catch (e) {
                    console.log(e);
                    reject(statusCode);
                }
            },
            error: function (statusCode) {
                reject(statusCode);
            }
        });
    });
}

function logout(expired) {
    var rtoken = Cookies.get('rtoken');
    var token = Cookies.get('token');
    var data = JSON.stringify({ "rtoken": rtoken, "token": token });

    $.ajax({
        "url": getManagerUrl() + "/auth",
        "method": "PUT",
        "headers": {
            "Content-Type": "application/json"
        },
        "data": data,
        success: function (response) {
            try {
                Cookies.remove('rtoken');
                Cookies.remove('token');
                Cookies.remove('user');
                Cookies.remove('expire');
                Cookies.remove('edgeHost');
                Cookies.set('expired', expired);
                Cookies.set('last_access', new Date());

                changePage('/login');
            } catch (e) {
                console.log(e);
                Cookies.remove('rtoken');
                Cookies.remove('token');
                Cookies.remove('user');
                Cookies.remove('expire');
                Cookies.remove('edgeHost');
                Cookies.set('expired', expired);
                Cookies.set('last_access', new Date());

                changePage('/login');
            }
        },
        error: function (statusCode) {
            Cookies.remove('rtoken');
            Cookies.remove('token');
            Cookies.remove('user');
            Cookies.remove('expire');
            Cookies.remove('edgeHost');
            Cookies.set('expired', expired);
            Cookies.set('last_access', new Date());

            changePage('/login');
        }
    });
}

function changePage(page) {
    window.location.pathname = getBasePath() + page;
}

function getLoginInfo() {
    return new Promise(function (resolve, reject) {
        var rtoken = Cookies.get('rtoken');
        if (rtoken) {
            var data = JSON.stringify({ "token": rtoken });
            makeLogin(data)
                .then(
                    function (data) {
                        resolve(data);
                    }
                ).catch(
                    function (error) {
                        changePage('/login');
                        reject();
                    }
                );
        } else {
            changePage('/login');
            reject();
        }
    });
}

function refreshPage() {
    window.location.reload(true);
}

function openPage(path) {
    window.location = window.location.origin + "/" + path;
}

function importCssFile(href) {
    var link = document.createElement('link');
    link.rel = 'stylesheet';
    link.type = 'text/css';
    link.href = href;
    document.head.appendChild(link);
}

function importJsFile(src) {
    var script = document.createElement("script");
    script.src = src;
    script.type = 'text/javascript';
    document.head.appendChild(script);
}

function addCssRule(selector, styleString) {
    var style = document.createElement("style");
    document.head.appendChild(style);

    var rule = selector + '{' + styleString + '}';
    var index = style.sheet.cssRules.length;
    style.sheet.insertRule(rule, index);
}

function showErrorPage(divElem) {
    var template;
    template =
        '<div class="error-page-content">' +
        '<div class="error-page-attachments">' +
        '<div class="error-page-info">' +
        '<div class="error-page-info-text">' +
        '<h1>Ooops, aconteceu algo errado...</h1>' +
        '<p>Não foi possível obter os dados a partir do servidor. Tente novamente mais tarde.</p>' +
        '</div>' +
        '</div>' +

        '<div class="error-page-actions">' +
        '<a href="javascript:void(0)" onclick="refreshPage();"><i class="fas fa-redo-alt"></i><span>Recarregar</span></a>' +
        '</div>' +
        '</div>' +
        '</div>';

    $('#' + divElem).html(template);
}