$('document').ready(function () {
    importCssFile('assets/css/menu.css');
});

function initLeftMenu(headerType) {
    $('body').append('<div id="left-menu" class="menu-content"></div>');

    $.ajax({
        dataType: "json",
        url: "assets/json/menu.json",
        success: function (options) {
            try{
                var localpath = window.location.pathname;
                var template;

                if (headerType === "logo") {
                    template =
                        '<div class="menu-header">' +
                        '<a href="' + getBasePath() + '/" class="menu-header-logo">' +
                        '<img id="manager-logo" src="' + getManagerUrl() + '/logo/main-logo.png"/>' +
                        '</a>' +
                        '</div>';

                } else {
                    //default headerType == "close"
                    template =
                        '<div class="menu-header">' +
                        '<a href="javascript:void(0)" class="menu-closebtn" onclick="closeLeftMenu()">&times;</a>' +
                        '</div>';
                }

                template += '<div class="menu-options">';
                for (var i = 0; i < options.length; i++) {

                    var icon = '';
                    var id = '';

                    if (options[i].icon) {
                        icon = '<i class="' + options[i].icon + '" style="width: 35px"></i>';
                    }

                    if (options[i].id) {
                        id = 'id="'+options[i].id+'"';
                    }

                    if (localpath == '/old-layout' && id == 'id="all-channels-menu"') {
                        continue;
                    }
                    

                    if (getBasePath() + options[i].href === localpath) {
                        template +=
                            '<div class="menu-selected">' +
                            '<a href="javascript:void(0)" onclick="closeLeftMenu()" '+id+'>' + icon + options[i].name + '</a>' +
                            '</div>';

                    } else {
                        template +=
                            '<div>' +
                            '<a href="' + getBasePath() + options[i].href + '" '+id+'>' + icon + options[i].name + '</a>' +
                            '</div>';
                    }
                }

                template += '</div>';

                $('#left-menu-button').show();
                $('#left-menu').html(template);
                loadChannelsMenu();
                toggleAllChannelsMenu();

            }catch(e){
                $('#left-menu-button').hide();
                console.log(e);
            }
        },
        error: function () {
            $('#left-menu-button').hide();
        }
    });
}

function openLeftMenu() {
    closeRightMenu();
    if (document.getElementById("left-menu")) {
        document.getElementById("left-menu").style.left = 0;
    }
}

function closeLeftMenu() {
    if (document.getElementById("left-menu")) {
        document.getElementById("left-menu").style.left = "-250px";
    }
}

function initRightMenu() {
    $('body').append('<div id="right-menu" class="menu-content"></div>');

    var user = Cookies.get('user');

    var template;
    template =
        '<div class="menu-header">' +
        '<a href="javascript:void(0)" class="menu-closebtn" onclick="closeRightMenu()">&times;</a>' +
        '</div>' +

        '<div class="menu-options">' +
        '<p>Olá, ' + user + '</p>' +
        '<div>' +
        '<a href="javascript:void(0)" onclick="logout(false)">Sair</a>' +
        '</div>' +
        '</div>';

    $('#right-menu-button').show();
    $('#right-menu').html(template);
}

function openRightMenu() {
    closeLeftMenu();
    if (document.getElementById("right-menu")) {
        document.getElementById("right-menu").style.right = 0;
    }
}

function closeRightMenu() {
    if (document.getElementById("right-menu")) {
        document.getElementById("right-menu").style.right = "-250px";
    }
}

function toggleAllChannelsMenu() {
    $('#all-channels-menu').on('click',function(e){
        e.preventDefault();
        if (!$(this).hasClass("opened")) {
            $(this).addClass("opened");
            $(this).parent().find('.sub-menu').css("display","block");
            $(this).html('<span>Todos os canais</span> <i class="fas fa-chevron-right"></i>');
        } else {
            $(this).removeClass("opened");
            $(this).parent().find('.sub-menu').css("display","none");
            $(this).html('<span>Todos os canais</span> <i class="fas fa-chevron-down"></i>');
        }
        
    });
}

function loadChannelsMenu(){
    getChannels("all").then(function(data){
        var template = "";
        var channels = data.channels;
        
        template += '<div class="sub-menu" style="display: none;">';
        for (i = 0; i < channels.length; i++) {
            template += '<div class="sub-item">';
            template += '<a href="theater?id='+channels[i].id+'"><span>'+ channels[i].number +'</span> ' + channels[i].name + '</a>';
            template += '</div>';
        }

        template += '</div>';
        $('#all-channels-menu').parent().append(template);
    });
    
}