var guideData = null;
var guideTemplate = null;

function resetGuideData() {
    guideData = {currentProgram: null, nextProgram: null};
}

function setGuideData(_guideData) {
    guideData = _guideData;
}

function getGuideData() {
    return guideData;
}

function setGuideTemplate(template) {
    guideTemplate = template;
}

function getGuideTemplate() {
    return guideTemplate;
}

function initGuide(parentElem, options) {
    importCssFile('assets/css/player-guide.css');

    var showLogoOnGuide = typeof options.showLogoOnGuide !== 'undefined' ? options.showLogoOnGuide : false;
    initGuideTemplate(showLogoOnGuide);
    resetGuideData();
    updateGuide(parentElem);
}

function initGuideTemplate(showLogo) {
    var displayLogo = "none";
    if (showLogo) {
        displayLogo = "block";
    }

    var template = '';
    template +=
        '<div id="guide-info" class="guide-info">' +
        '<div class="guide-info-logo" style="display: ' + displayLogo + ';">' +
        '<img src="' + getChannelObj().logo + '">' +
        '</div>' +
        '<div>' +
        '<div id="guide-current" class="guide-program" style="display: none;">' +
        '<div>' +
        '<span class="guide-program-time"></span>' +
        '<span class="guide-program-name">' +
        '<span class="guide-program-label">Agora</span>' +
        '</span>' +
        '</div>' +
        '<div>' +
        '<span class="guide-program-time" id="guide-current-program-time"></span>' +
        '<span class="guide-program-name" id="guide-current-program"></span>' +
        '</div>' +
        '</div>' +
        '<div id="guide-next" class="guide-program" style="display: none;">' +
        '<div>' +
        '<span class="guide-program-time"></span>' +
        '<span class="guide-program-name">' +
        '<span class="guide-program-label">A Seguir</span>' +
        '</span>' +
        '</div>' +
        '<div>' +
        '<span class="guide-program-time" id="guide-next-program-time"></span>' +
        '<span class="guide-program-name" id="guide-next-program"></span>' +
        '</div>' +
        '</div>' +
        '</div>' +
        '</div>';
    setGuideTemplate(template);
}

function updateGuide(parentElem) {
    if ($('#guide-info').length === 0) {
        $(parentElem).append(getGuideTemplate());
    }

    getChannelGuide(getChannelObj())
        .then(
            function (guide) {
                var current_program = null, next_program = null;
                if (guide[0]) {
                    current_program = guide[0];
                }
                if (guide[1]) {
                    next_program = guide[1];
                }

                var guideData = {currentProgram: current_program, nextProgram: next_program};
                setGuideData(guideData);
                showGuideElements();
            }
        ).catch(
        function () {
            hideGuideElements();
            resetGuideData();
        }
    );
}

function showGuideElements() {
    var start, startText, stop, stopText;
    if (getGuideData().currentProgram) {
        start = new Date(getGuideData().currentProgram.start.replace(" ", "T") + "Z");
        startText = ('0' + start.getHours()).slice(-2) + ":" + ('0' + start.getMinutes()).slice(-2);

        stop = new Date(getGuideData().currentProgram.stop.replace(" ", "T") + "Z");
        stopText = ('0' + stop.getHours()).slice(-2) + ":" + ('0' + stop.getMinutes()).slice(-2);

        $('#guide-current-program-time').text(startText + " - " + stopText);
        $('#guide-current-program').text(getGuideData().currentProgram.title);
        $('#guide-current').show();
    } else {
        $('#guide-current').hide();
    }

    if (getGuideData().nextProgram) {
        start = new Date(getGuideData().nextProgram.start.replace(" ", "T") + "Z");
        startText = ('0' + start.getHours()).slice(-2) + ":" + ('0' + start.getMinutes()).slice(-2);

        stop = new Date(getGuideData().nextProgram.stop.replace(" ", "T") + "Z");
        stopText = ('0' + stop.getHours()).slice(-2) + ":" + ('0' + stop.getMinutes()).slice(-2);

        $('#guide-next-program-time').text(startText + " - " + stopText);
        $('#guide-next-program').text(getGuideData().nextProgram.title);
        $('#guide-next').show();
    } else {
        $('#guide-next').hide();
    }
}

function hideGuideElements() {
    $('#guide-current').hide();
    $('#guide-next').hide();
}