$('document').ready(function () {
    initMain().then(function () {
        initTheater();
    });
});

function initTheater() {
    importCssFile('assets/css/theater.css');
    getLoginInfo()
        .then(
            function (data) {
                initTheaterData();
                $("body").show();
            }
        );
}

function initTheaterData() {
    var url_string = window.location.href;
    var url = new URL(url_string);
    var channelId = url.searchParams.get("id");

    initRenewToken();
    initStillWatchingModal();
    initRestrictModal();
    initLeftMenu();

    getChannelInfo(channelId)
        .then(
            function (data) {
                initTheaterPage(data);
            }
        ).catch(
        function () {
            showErrorPage("theater-main-elem")
        }
    );
}

function initTheaterPage(channel) {
    fillTheaterPageTemplate();
    var token = Cookies.get('token');
    var options = {
        "fixed": true,
        "hideMediaControl": true,
        "plugins": ["LevelSelector", "ChromecastPlugin"],
        "mediaControlRemove": ["seekbar", "position", "duration", "playpause", "playstop"],
        "guideParentElem": "#theater-overlay",
        "showLogoOnGuide": true,
        "overlayElem": "#theater-overlay",
        "aonly" : typeof channel.aonly == 'undefined' ? false : channel.aonly,
    };
    /** TODO: Search here for channel categories and see if is >= 18 */
    if (channel.rating > 16) {

        if (isRestrict() == false){
            setIsRestrict(false);
        } else {
            setIsRestrict(true);
        }
    }

    if(isRestrict()) {
        showRestrictModal();
    }else{
        initPlayer(channel, "player", options);
    }
}

function validateRestrictPassword() {
    var pass = $("#pwd-restrict").val(); 
    var parpass = Cookies.get("parpass");
    if (sha1(pass) == parpass) {
        setIsRestrict(false);
        hideRestrictModal(); 
        initTheaterData();
    }
    return false;
}

function showAllChannels() {
        $('#all-channels-menu').addClass("opened");
        $('#all-channels-menu').html('<span>Todos os canais</span> <i class="fas fa-chevron-right"></i>');
        $('.sub-menu').show();
}

function fillTheaterPageTemplate() {
    var template;
    template =
        '<div class="theater-player">' +
        '<div class="player-container" id="player"></div>' +
        '</div>' +

        '<div class="theater-overlay" id="theater-overlay" style="">' +
            '<div class="theater-overlay-home-button">' +
                '<a href="' + getBasePath() + '/"><i class="fas fa-chevron-left"></i><span>Voltar ao Início</span></a>' +
            '</div>' +
            '<div class="theater-overlay-menu-button">'+ 
                '<a href="#" onclick="openLeftMenu()"><i class="fas fa-bars"></i></a>' +
            '</div>'+
        '</div>';

    $('#theater-main-elem').html(template);
}