$('document').ready(function () {
    initToast();
});

function initToast() {
    document.body.innerHTML += '<div id="toast-top"></div><div id="toast-middle"></div><div id="toast-bottom"></div>';

    addCssRule("#toast-top",
        "visibility: hidden;" +
        "min-width: 250px;" +
        "margin-left: -125px;" +
        "background-color: #333;" +
        "color: #fff;" +
        "text-align: center;" +
        "border-radius: 10px;" +
        "padding: 16px;" +
        "position: fixed;" +
        "z-index: 1;" +
        "left: 50%;" +
        "top: 30px;" +
        "font-size: 17px;"
    );

    addCssRule("#toast-top.show",
        "visibility: visible;" +
        "-webkit-animation: fadein-top 0.5s;" +
        "animation: fadein-top 0.5s;"
    );

    addCssRule("#toast-top.hide",
        "visibility: visible;" +
        "-webkit-animation: fadeout-top 0.5s 0s;" +
        "animation: fadeout-top 0.5s 0s;"
    );

    addCssRule("@-webkit-keyframes fadein-top",
        "from {top: 0; opacity: 0;}" +
        "to {top: 30px; opacity: 1;}"
    );

    addCssRule("@keyframes fadein-top",
        "from {top: 0; opacity: 0;}" +
        "to {top: 30px; opacity: 1;}"
    );

    addCssRule("@-webkit-keyframes fadeout-top",
        "from {top: 30px; opacity: 1;}" +
        "to {top: 0; opacity: 0;}"
    );

    addCssRule("@keyframes fadeout-top",
        "from {top: 30px; opacity: 1;}" +
        "to {top: 0; opacity: 0;}"
    );

    addCssRule("#toast-middle",
        "visibility: hidden;" +
        "min-width: 250px;" +
        "margin-left: -125px;" +
        "background-color: #333;" +
        "color: #fff;" +
        "text-align: center;" +
        "border-radius: 10px;" +
        "padding: 16px;" +
        "position: fixed;" +
        "z-index: 1;" +
        "left: 50%;" +
        "top: 50%;" +
        "font-size: 17px;"
    );

    addCssRule("#toast-middle.show",
        "visibility: visible;" +
        "-webkit-animation: fadein-middle 0.5s;" +
        "animation: fadein-middle 0.5s;"
    );

    addCssRule("#toast-middle.hide",
        "visibility: visible;" +
        "-webkit-animation: fadeout-middle 0.5s 0s;" +
        "animation: fadeout-middle 0.5s 0s;"
    );

    addCssRule("@-webkit-keyframes fadein-middle",
        "from {top: 0; opacity: 0;}" +
        "to {top: 50%; opacity: 1;}"
    );

    addCssRule("@keyframes fadein-middle",
        "from {top: 0; opacity: 0;}" +
        "to {top: 50%; opacity: 1;}"
    );

    addCssRule("@-webkit-keyframes fadeout-middle",
        "from {top: 50%; opacity: 1;}" +
        "to {top: 0; opacity: 0;}"
    );

    addCssRule("@keyframes fadeout-middle",
        "from {top: 50%; opacity: 1;}" +
        "to {top: 0; opacity: 0;}"
    );

    addCssRule("#toast-bottom",
        "visibility: hidden;" +
        "min-width: 250px;" +
        "margin-left: -125px;" +
        "background-color: #333;" +
        "color: #fff;" +
        "text-align: center;" +
        "border-radius: 10px;" +
        "padding: 16px;" +
        "position: fixed;" +
        "z-index: 1;" +
        "left: 50%;" +
        "bottom: 30px;" +
        "font-size: 17px;"
    );

    addCssRule("#toast-bottom.show",
        "visibility: visible;" +
        "-webkit-animation: fadein-bottom 0.5s;" +
        "animation: fadein-bottom 0.5s;"
    );

    addCssRule("#toast-bottom.hide",
        "visibility: visible;" +
        "-webkit-animation: fadeout-bottom 0.5s 0s;" +
        "animation: fadeout-bottom 0.5s 0s;"
    );

    addCssRule("@-webkit-keyframes fadein-bottom",
        "from {bottom: 100%; opacity: 0;}" +
        "to {bottom: 30px; opacity: 1;}"
    );

    addCssRule("@keyframes fadein-bottom",
        "from {bottom: 100%; opacity: 0;}" +
        "to {bottom: 30px; opacity: 1;}"
    );

    addCssRule("@-webkit-keyframes fadeout-bottom",
        "from {bottom: 30px; opacity: 1;}" +
        "to {bottom: 100%; opacity: 0;}"
    );

    addCssRule("@keyframes fadeout-bottom",
        "from {bottom: 30px; opacity: 1;}" +
        "to {bottom: 100%; opacity: 0;}"
    );
}

function toast(message, duration, position) {
    if (!duration) {
        duration = 5;
    }

    if (!position) {
        position = "bottom"
    }

    //duration to ms
    duration *= 1000;

    var toast = document.getElementById("toast-" + position);
    toast.innerHTML = message;
    toast.className = "show";
    setTimeout(function () {
        toast.className = toast.className.replace("show", "hide");
        setTimeout(function () {
            toast.className = toast.className.replace("hide", "");
        }, 500); //Wait 0.5s (fadeout time) to hide toast
    }, duration);
}