var renewTokenTime;

function initRenewToken() {
    console.log("RenewToken")
    var now = new Date();
    var expire = parseInt(Cookies.get('expire'));
    var lifetime = expire - now.getTime();
    var renewTime = parseInt(lifetime / 10);
    setRenewTokenTime(renewTime);

    if (!isDemo()) {
        setTimeout(renewToken, renewTime);
    }
}

function renewToken() {
    console.log("RenewToken2")
    var token = Cookies.get('token');
    var rtoken = Cookies.get('rtoken');
    var expire = parseInt(Cookies.get('expire'));
    var now = new Date();
    var lat = Cookies.get('lat');
    var lon = Cookies.get('lon');

    var userAgent = navigator.userAgent+" cdntv-web/"+getCurrentVersion();
    
    if (rtoken) {
        var data = JSON.stringify({"token": rtoken,"location":{"latitude": lat,"longitude": lon},"useragent": userAgent});
        console.log(data);
        var myHeaders = new Headers({
            "Accept": "application/json",
            "Content-Type": "application/json"
        });
        
        var myInit = {
            method: 'POST',
            headers: myHeaders,
            crossDomain: true,
            data: data,
            dataType: 'json',
            mode: 'cors'
        }

        var error = (e) =>{
            console.log(e);
            if (!token || now.getTime() > expire) {
                logout(true);
            } else {
                setTimeout(renewToken, getRenewTokenTime());
            }
        }

        fetch(getManagerUrl() + "/auth",myInit)
        .then(response => {
            try {
                return response.json();
            } catch (e) {
                error(e)
            }
        })
        .then(data => {
            try{
                var lifetime = response.lifetime * 1000;
                expire = now.getTime() + lifetime;

                Cookies.set('token', data.token);
                Cookies.set('expire', expire);
                initRenewToken();
            }catch(e){
                error(e);
            }
        })
        .catch(error =>{
            error(e);
        })
        
    } else {
        logout(false);
    }
}

function setRenewTokenTime(_time) {
    renewTokenTime = _time;
}

function getRenewTokenTime() {
    return renewTokenTime;
}

function changeToken(changeTokenTime, options) {
    var now = new Date();

    if (now.getTime() > changeTokenTime) {
        stopPlayer();
        if (options.trailerMode) {
            endTrailerMode(options);
        } else if (isEconomic() || isDemo()) {
            showStillWatchingModal();
        } else {
            refreshPlayer();
        }
    }
}

function checkTokenExpire(options) {
    var expire = parseInt(Cookies.get('expire'));
    var now = new Date();
    var diff = expire - now.getTime();
    diff = parseInt(diff * 0.8); //renew token some time before expire
    console.log(`diff=${diff}`)
    var changeTokenTime = now.getTime() + parseInt(diff * 0.8); //margin of error

    setTimeout(function () {
        changeToken(changeTokenTime, options);
    }, diff);
}